SystemOrganization addCategory: #SimpleApplescript!
SystemOrganization addCategory: #'SimpleApplescript-Specifications'!

TestCase subclass: #ApplescriptSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Specifications'!

!ApplescriptSpecification methodsFor: 'tests' stamp: 'SeanDeNigris 12/6/2011 09:36'!
testDoIt

	| result |
	result := Applescript doIt: 'get item 1 of {"one", "two", "three"}'.
	self assert: (result = '"one"').! !

!ApplescriptSpecification methodsFor: 'tests' stamp: 'SeanDeNigris 12/6/2011 09:48'!
testDoItError

	self should: [ Applescript doIt: 'get item 1 of {"one"'] raise: Error whoseDescriptionIncludes: 'syntax error:' description: ''.
! !

Object subclass: #Applescript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript'!

!Applescript commentStamp: 'SeanDeNigris 12/6/2011 09:55' prior: 0!
I execute Applescript scripts via my class side #doIt:.

I am a bare-bones replacement for the class of the same name in the Applescript project (on Squeaksource) because the required plugin does not work on the new Cocoa Cog VMs.!

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 3/27/2012 10:07'!
asOldManSay: aString
	"self asOldManSay: 'you damn kids get off my lawn'"

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Bahh"'.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 3/14/2012 19:23'!
asYoungGirlSay: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Princess"'.! !

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 10/24/2012 23:06'!
doIt: aString 

	|  escapedString command process output tmpFile |
	"We're using -e with a double-quoted string to pass our (possibly) multi-line string. A heredoc that was perfectly valid when used in the shell still didn't seem to work here"
	tmpFile := Smalltalk imagePath asFile / 'tmp_applescript_file'.
	FileStream forceNewFileNamed: tmpFile fullName do: [ :fs | fs nextPutAll: aString ].

	escapedString := self makeSafeForMultiline: aString.
	command := '/usr/bin/osascript -ss ', $" asString, tmpFile fullName, $" asString.
	process := PipeableOSProcess waitForCommand: command.
	process succeeded ifFalse: [ self error: process errorUpToEndOfFile ].
	output := process output withoutTrailingBlanks.
	process closePipes. "Per http://forum.world.st/Proper-way-to-use-many-PipeableOSProcesses-td69586.html"
	^ output.
! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 1/6/2012 11:38'!
escapeDoubleQuotesIn: aString
	"Should be in String, but this is all very experimental, so I'm keeping it contained"

	^ aString copyReplaceAll: '"' with: '\"' asTokens: false.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/24/2012 16:19'!
escapeTabsIn: aString 

	^ aString copyWithout: Character tab.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/24/2012 16:37'!
makeSafeForMultiline: aString

	| tabsEscaped |
	tabsEscaped := self escapeTabsIn: aString.
	^ self escapeDoubleQuotesIn: tabsEscaped.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/16/2012 21:56'!
say: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/6/2012 12:55'!
smalltalkifyOutput: aString 

	aString = 'true' ifTrue: [ ^ true ].
	aString = 'false' ifTrue: [ ^ false ].
	^ aString.! !
